import peasy.*;
//import net.java.games.jogl.*;
import processing.opengl.*;

PeasyCam cam;
// GL gl;

float axis_X = 0;
float axis_Y = 0;
float axis_Z = 0;

float control_X = 100;
float control_Y = 100;
float control_Z = 0;

float offset_X = 0;
float offset_Y = 100;
float offset_Z = 0;

int totalSegments = 10;

PVector[] orbit = new PVector[totalSegments];
Segment[] segments = new Segment[totalSegments];

PVector segmentOffset;

void setup() {
	size(1200,800,P3D); 
	// gl = ((PGraphicsGL)g).gl;
	// gl.glEnable(GL.GL_CULL_FACE);

	cam = new PeasyCam(this, 1000);
	cam.setMinimumDistance(50);
	cam.setMaximumDistance(2000);

	
    // --------------------------------------------------------------------
    // parse data
    // --------------------------------------------------------------------

	for(int i=0;i<totalSegments;i++){
		segments[i] = new Segment();
		if(i==0){
			segments[i].previousSegment = segments[0];
		} else {
			segments[i].previousSegment = segments[i-1];
		}
		
		segments[i].seed = i;
	}

}
void draw() {
	
	background(0);
	
	drawAxes(400);
	
	// --------------------------------------------------------------------
	// draw base 
	// --------------------------------------------------------------------
	float angleX,angleY;
	int i,j,k;
	float percentage;

	segmentOffset = new PVector(0,0,0);
	// --------------------------------------------------------------------
	// parse data
	// --------------------------------------------------------------------
	
	// custom position of segment 2
	// to see values change easily
	
	
	
	segments[1].endRelativeVec.y = .5*(mouseY-height/2);
	segments[1].endRelativeVec.x = .5*(mouseX-width/2);
	segments[1].resetRelatives();
	
	segments[3].endRelativeVec.y = -.25*(mouseY-height/2);
	segments[3].endRelativeVec.x = -.25*(mouseX-width/2);
	segments[3].resetRelatives();
	
	
	for(i=0;i<totalSegments;i++){
		calculateSegmentPosition(i);
		segments[i].resetRelatives();

	}
	


	i = 0;
	segments[i].setPreviousOrbit(segments[i].startOrbit);
	segments[i].setNextOrbit(segments[i+1].startOrbit);
	segments[i].parseLerps();
	
	for(i=1;i<(totalSegments-1);i++){
		segments[i].setPreviousOrbit(segments[i-1].endOrbit);
		segments[i].setNextOrbit(segments[i+1].startOrbit);
		segments[i].parseLerps();
	}

	i = totalSegments-1;
	segments[i].setPreviousOrbit(segments[i-1].endOrbit);
	segments[i].setNextOrbit(segments[i].endOrbit);
	segments[i].parseLerps();
	
	
	for(i=0;i<totalSegments;i++){
		segments[i].draw();
		// segments[i].drawWireframes();
		// segments[i].drawGuides();
	}
}


void calculateSegmentPosition(int i){

	segments[i].createAbsolutes();
	segments[i].updateAbsolutes(segmentOffset);
	segmentOffset.add(segments[i].endRelativeVec.get());
	segments[i].parse();
}



void keyPressed() {
	if (key == 'r' || key == 'R') {
		for(int i=0;i<totalSegments;i++){
			segments[i].createRelatives();
			segments[i].resetRelatives();
			segments[i].createAbsolutes();
		}
	}
}

void drawAxes(float radius) {
  noFill();
  strokeWeight(1);
  stroke(255, 0, 0,255);
  line(0, 0, 0, radius, 0, 0);
  stroke(0, 255, 0,255);
  line(0, 0, 0, 0, radius, 0);
  stroke(0, 0, 255,255);
  line(0, 0, 0, 0, 0, radius);

  stroke(#00FF00,51);
  pushMatrix();
  translate(0, radius,0);
  box(10);
  popMatrix();             

  stroke(#FF0000,51);
  pushMatrix();
  translate(radius, 0,0);
  box(10);
  popMatrix(); 

  stroke(#0000FF,51);
  pushMatrix();
  translate(0, 0,radius);
  box(10);
  popMatrix(); 

  stroke(#FFFFFF,51);
  ellipse(0, 0, 200, 200);

  stroke(#FFFFFF,51);
  box(radius*2);
}

